# All files / src/storages MapStorage.ts

78.26% Statements 18/23
50% Branches 4/8
100% Functions 0/0
77.27% Lines 17/22

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    951x

    1x

    1x
    1x

    1x

    1x

    1x

    222x

    1815x

    700x

    223x
    223x

    6x
    6x

    6x
    6x

    358x

     import { injectable } from 'inversify';

    import { IStorage } from '../interfaces/storages/IStorage';

    import { initializable } from '../decorators/Initializable';

    import { RandomGeneratorUtils } from '../utils/RandomGeneratorUtils';
    import { Utils } from '../utils/Utils';

    @injectable()
    export abstract class MapStorage <T> implements IStorage <T> {
        /**
         * @type {string}
         */
        @initializable()
        protected storageId: string;

        /**
         * @type {Map <string | number, T>}
         */
        @initializable()
        protected storage: Map <string | number, T>;

        /**
         * @param key
         * @returns {T}
         */
        public get (key: string | number): T {
            const value: T | undefined = this.storage.get(key);

            if (!value) {
                throw new Error(`No value found in map storage with key \`${key}\``);
            }

            return value;
        }

        /**
         * @param value
         * @returns {string | number | null}
         */
        public getKeyOf (value: T): string | number | null {
            return Utils.mapGetFirstKeyOf <string | number, T> (this.storage, value);
        }

        /**
         * @returns {number}
         */
        public getLength (): number {
            return Array.from(this.storage).length;
        }

        /**
         * @returns {Map <string | number, T>}
         */
        public getStorage (): Map <string | number, T> {
            return this.storage;
        }

        /**
         * @returns {string}
         */
        public getStorageId (): string {
            return this.storageId;
        }

        /**
         * @param args
         */
        public initialize (...args: any[]): void {
            this.storage = new Map <string | number, T> ();
            this.storageId = RandomGeneratorUtils.getRandomString(6);
        }

        /**
         * @param storage
         * @param mergeId
         */
        public mergeWith (storage: this, mergeId: boolean = false): void {
            this.storage = new Map <string | number, T> ([...this.storage, ...storage.getStorage()]);

            Eif (mergeId) {
                this.storageId = storage.getStorageId();
            }
        }

        /**
         * @param key
         * @param value
         */
        public set (key: string | number, value: T): void {
            this.storage.set(key, value);
        }
    }